package br.ufes.nemo.seon.ontoloyasservice.generator.lib;

import br.ufes.nemo.seon.ontoloyasservice.oaas.Configuration;
import com.google.common.collect.Iterables;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class HelpersGenerator extends AbstractGenerator {
  private String ONTOLOGYSHORTNAME = "";
  
  private String PATH_LIB_HELPER = "lib/src/";
  
  private String LEVEL = "";
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<Configuration> _filter = Iterables.<Configuration>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Configuration.class);
    for (final Configuration configuration : _filter) {
      {
        this.LEVEL = configuration.getLevel().getName().toLowerCase();
        boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(this.ONTOLOGYSHORTNAME);
        if (_isNullOrEmpty) {
          String _lowerCase = configuration.getOntologyShortName().getName().toLowerCase();
          String _plus = (_lowerCase + "_lib/");
          this.ONTOLOGYSHORTNAME = _plus;
        }
      }
    }
    boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(this.ONTOLOGYSHORTNAME);
    boolean _not = (!_isNullOrEmpty);
    if (_not) {
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "__init__.py"), "");
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "application/__init__.py"), "");
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "application/abstract_application.py"), this.createAbstractApplication(this.ONTOLOGYSHORTNAME));
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "service/__init__.py"), "");
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "service/base_service.py"), this.createBaseService(this.ONTOLOGYSHORTNAME));
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "model/__init__.py"), "");
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "model/core/__init__.py"), "");
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "model/core/models.py"), this.createCoreModels(this.ONTOLOGYSHORTNAME));
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "config/__init__.py"), "");
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "config/base.py"), this.createBase());
      fsa.generateFile(((this.PATH_LIB_HELPER + this.ONTOLOGYSHORTNAME) + "config/config.py"), this.createConfig());
    }
  }
  
  public CharSequence createCoreModels(final String lib_name) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from sqlalchemy import Column, String,ForeignKey, Integer");
    _builder.newLine();
    _builder.append("from sqlalchemy.orm import relationship");
    _builder.newLine();
    _builder.append("from sqlalchemy.ext.declarative import declarative_base");
    _builder.newLine();
    _builder.append("from sqlalchemy_utils import UUIDType, URLType");
    _builder.newLine();
    _builder.append("from ");
    _builder.append(lib_name);
    _builder.append(".config.base import Entity");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("class ApplicationType (Entity):");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Represents a Type of Application.\"\"\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("__tablename__ = \"application_type\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("application = relationship(\"Application\", back_populates=\"application_type\")");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("class Application(Entity):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Represents an Application.\"\"\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("__tablename__ = \"application\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("application_type_id = Column(Integer, ForeignKey(\'application_type.id\'))");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("application_type = relationship(\"ApplicationType\", back_populates=\"application\")");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("configuration = relationship(\"Configuration\", back_populates=\"application\")");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __str__(self):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.name");
    _builder.newLine();
    _builder.newLine();
    _builder.append("class Configuration(Entity):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Represents an Configuation of an application.\"\"\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("__tablename__ = \"configuration\"");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("secret = Column(String(200), nullable=False)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("url = Column(URLType)");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("application_id = Column(Integer, ForeignKey(\'application.id\'))");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("application = relationship(\"Application\", back_populates=\"configuration\")");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("organization_id = Column(Integer, ForeignKey(\'organization.id\'))");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("organization = relationship(\"Organization\", back_populates=\"configuration\") ");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    _builder.append("class ApplicationReference(Entity):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Represents an referece of an entity in an application.\"\"\"");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("__tablename__ = \"application_reference\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("# external application\'s data");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("configuration = Column(Integer, ForeignKey(\'configuration.id\'))");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("external_id = Column(String(200), nullable=False)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("external_url = Column(URLType)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("external_type_entity = Column(String(200), nullable=False)");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("#Internal BD");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("internal_uuid = Column(UUIDType(binary=False))");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("entity_name = Column(String(200), nullable=False)");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence createBaseService(final String lib_name) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from abc import ABC");
    _builder.newLine();
    _builder.append("from sqlalchemy import create_engine");
    _builder.newLine();
    _builder.append("from sqlalchemy.orm import sessionmaker");
    _builder.newLine();
    _builder.append("from ");
    _builder.append(lib_name);
    _builder.append(".config.config import engine");
    _builder.newLineIfNotEmpty();
    _builder.append("from ");
    _builder.append(lib_name);
    _builder.append(".model.core.models import ApplicationReference");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("class BaseService(ABC):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Abstract Class responsible for implemeting functions that are common in a service. \"\"\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __init__(self, object):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.object = object");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.type = self.object.__tablename__");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __create_session_connection(self):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("Session = sessionmaker(bind=engine,autocommit=True)");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.session = Session()");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.session.begin(subtransactions=True)");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __close_session_connection(self):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.session.close()");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_all(self):");
    _builder.newLine();
    _builder.append("    \t");
    _builder.append("self.__create_session_connection()");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("results = self.session.query(self.object).order_by(self.object.id).all()");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return results");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_by_uuid(self, uuid):");
    _builder.newLine();
    _builder.append("    \t");
    _builder.append("self.__create_session_connection()");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.session.query(self.object).filter(self.object.uuid == uuid).first()");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def create(self, object):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.__create_session_connection()");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("try:");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.add(object)");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.commit()");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("except:");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.rollback() ");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("raise");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def update(self, object):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.__create_session_connection()");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("try:");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.query(self.object).filter(self.object.id == object.id).update({column: getattr(object, column) for column in self.object.__table__.columns.keys()})");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.commit()");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("except:");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.rollback() ");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("raise");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def delete(self, object):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.__create_session_connection()");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("try:");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.delete(object)");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("self.session.commit()");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("except:");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.session.rollback() ");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("raise");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence createAbstractApplication(final String lib_name) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from abc import ABC");
    _builder.newLine();
    _builder.append("from sqlalchemy import update");
    _builder.newLine();
    _builder.append("from pprint import pprint");
    _builder.newLine();
    _builder.append("from rabbitmqX.journal.journal import Journal");
    _builder.newLine();
    _builder.append("from rabbitmqX.patterns.client.topic_client import Topic_Client");
    _builder.newLine();
    _builder.append("from ");
    _builder.append(lib_name);
    _builder.append(".model.core.models import ApplicationReference, Configuration");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("class AbstractApplication(ABC):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Abstract Class responsible for implemeting functions that are common in a Application. \"\"\" ");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __init__(self, service):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.service = service");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_all (self):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.service.find_all()");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __send_object(self, object, action):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.topic_client = Topic_Client(\"");
    _builder.append(this.LEVEL, "\t\t");
    _builder.append(".");
    _builder.append(this.ONTOLOGYSHORTNAME, "\t\t");
    _builder.append(".\"+object.is_instance_of)");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("journal = Journal(str(object.uuid),object.is_instance_of,object.to_dict(),action)");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.topic_client.send(journal)");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def create(self, object):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.service.create (object)");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("self.__send_object(object, \"create\")");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def ___find_by_external_id_and_seon_entity_name (self, external_id, seon_entity_name):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if isinstance(external_id, int):");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("external_id = str(external_id)");
    _builder.newLine();
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.service.session.query(ApplicationReference).filter(ApplicationReference.external_id == external_id, ");
    _builder.newLine();
    _builder.append("                                                               ");
    _builder.append("ApplicationReference.entity_name == seon_entity_name).first()");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def ___find_by_external_url_and_seon_entity_name (self, external_url, seon_entity_name):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.service.session.query(ApplicationReference).filter(ApplicationReference.external_url == external_url, ");
    _builder.newLine();
    _builder.append("                                                               ");
    _builder.append("ApplicationReference.entity_name == seon_entity_name).first()");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_by_external_url(self, external_url):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("        ");
    _builder.append("application_reference = self.___find_by_external_url_and_seon_entity_name(external_url, self.service.type)");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if application_reference:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("return self.service.find_by_uuid(application_reference.internal_uuid)");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return None");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_by_external_uuid(self, external_uuid):");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if isinstance(external_uuid, int):");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("external_uuid = str(external_uuid)");
    _builder.newLine();
    _builder.newLine();
    _builder.append("        ");
    _builder.append("application_reference = self.___find_by_external_id_and_seon_entity_name(external_uuid, self.service.type)");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if application_reference:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("return self.service.get_by_uuid(application_reference.internal_uuid)");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return None");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def ___find_by_external_id_and_seon_entity_name_and_configuration_uuid (self, external_id, seon_entity_name,configuration_uuid):");
    _builder.newLine();
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if isinstance(external_id, int):");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("external_id = str(external_id)");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if isinstance(configuration_uuid, int):");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("configuration_uuid = str(configuration_uuid)");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("configuration = self.service.session.query(Configuration).filter(Configuration.uuid == configuration_uuid).first()");
    _builder.newLine();
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.service.session.query(ApplicationReference).filter(ApplicationReference.external_id == external_id, ");
    _builder.newLine();
    _builder.append("                                                               ");
    _builder.append("ApplicationReference.entity_name == seon_entity_name,");
    _builder.newLine();
    _builder.append("                                                               ");
    _builder.append("ApplicationReference.configuration == configuration.id).first()");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_by_external_uuid_and_configuration_uuid(self, external_uuid, configuration_uuid):");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if isinstance(external_uuid, int):");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("external_uuid = str(external_uuid)");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if isinstance(configuration_uuid, int):");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("configuration_uuid = str(configuration_uuid)");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("application_reference = self.___find_by_external_id_and_seon_entity_name_and_configuration_uuid(external_uuid, self.service.type,configuration_uuid)");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("if application_reference:");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("return self.service.find_by_uuid(application_reference.internal_uuid)");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return None");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def update (self, object):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.service.update(object)");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("self.__send_object(object, \"create\")");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_by_name (self, name):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.service.find_by_name(name)");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def find_by_uuid (self, uuid):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.service.find_by_uuid(uuid)");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence createConfig() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from sqlalchemy import create_engine");
    _builder.newLine();
    _builder.append("from sqlalchemy.ext.declarative import declarative_base");
    _builder.newLine();
    _builder.append("from sqlalchemy.orm import sessionmaker");
    _builder.newLine();
    _builder.newLine();
    _builder.append("SQLALCHEMY_DATABASE_URI = \"postgres://seon:seon@localhost/");
    _builder.append(this.ONTOLOGYSHORTNAME);
    _builder.append("_ontology\"");
    _builder.newLineIfNotEmpty();
    _builder.append("engine = create_engine(SQLALCHEMY_DATABASE_URI)");
    _builder.newLine();
    _builder.append("Base = declarative_base()");
    _builder.newLine();
    _builder.newLine();
    _builder.append("class Config():");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Represents an abstract class that will be used to another models.\"\"\"");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def create_database(self):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("Base.metadata.create_all(engine)");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence createBase() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from .config import Base");
    _builder.newLine();
    _builder.append("import datetime");
    _builder.newLine();
    _builder.append("from sqlalchemy import Column, String, Integer, DateTime, Table, ForeignKey, Text");
    _builder.newLine();
    _builder.append("from sqlalchemy.orm import relationship");
    _builder.newLine();
    _builder.append("from sqlalchemy_utils import UUIDType");
    _builder.newLine();
    _builder.append("from sqlalchemy_serializer import SerializerMixin");
    _builder.newLine();
    _builder.append("import uuid");
    _builder.newLine();
    _builder.newLine();
    _builder.append("class Entity(Base, SerializerMixin):");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("\"\"\" Represents an abstract class that will be used to another models.\"\"\"");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("__abstract__  = True");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("serialize_rules =(\'-id\', \"-uuid\")");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("id = Column(Integer, primary_key=True)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("uuid = Column(UUIDType(binary=False), unique=True, nullable=False, default=uuid.uuid4)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("date_created  = Column(DateTime,  default=datetime.datetime.utcnow)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("date_modified = Column(DateTime,  default=datetime.datetime.utcnow,onupdate=datetime.datetime.utcnow)    ");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("name = Column(String(200), nullable=True)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("description = Column(Text(), nullable=True)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("is_instance_of = \"\"");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def entity_name(self):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return self.is_instance_of");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def __repr__(self):");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("return super().__repr__()");
    _builder.newLine();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def to_dict(self):");
    _builder.newLine();
    _builder.append("    \t");
    _builder.append("dict = super().to_dict()");
    _builder.newLine();
    _builder.append("    \t");
    _builder.append("dict[\'uuid\'] = self.uuid_()");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("dict[\'level\'] = \"domain\"");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("dict[\'ontology\'] = \"sro\"");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("dict[\'is_instance_of\'] = str(self.is_instance_of)");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return dict");
    _builder.newLine();
    _builder.append("        ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("def uuid_(self):");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return str(self.uuid)");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
